import { renderless, api } from "@xmweb-ui/vue-renderless/dropdown-menu/vue";
import { defineComponent, props, setup as _setup } from "@xmweb-ui/vue-common";
import Tooltip from "@xmweb-ui/vue-tooltip";
import { resolveComponent, openBlock, createBlock, Transition, withCtx, withDirectives, createElementVNode, normalizeClass, normalizeStyle, createVNode, renderSlot, vShow } from "vue";
function _createForOfIteratorHelperLoose(o, allowArrayLike) {
  var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"];
  if (it)
    return (it = it.call(o)).next.bind(it);
  if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") {
    if (it)
      o = it;
    var i = 0;
    return function() {
      if (i >= o.length)
        return { done: true };
      return { done: false, value: o[i++] };
    };
  }
  throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}
function _unsupportedIterableToArray(o, minLen) {
  if (!o)
    return;
  if (typeof o === "string")
    return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor)
    n = o.constructor.name;
  if (n === "Map" || n === "Set")
    return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))
    return _arrayLikeToArray(o, minLen);
}
function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length)
    len = arr.length;
  for (var i = 0, arr2 = new Array(len); i < len; i++)
    arr2[i] = arr[i];
  return arr2;
}
var _export_sfc = function _export_sfc2(sfc, props) {
  var target = sfc.__vccOpts || sfc;
  for (var _iterator = _createForOfIteratorHelperLoose(props), _step; !(_step = _iterator()).done; ) {
    var _step$value = _step.value, key = _step$value[0], val = _step$value[1];
    target[key] = val;
  }
  return target;
};

var _sfc_main = defineComponent({
  props: [].concat(props, ["visibleArrow", "arrowOffset", "placement", "popperClass", "popperAppendToBody", "checkedStatus", "multiStage", "maxHeight"]),
  emits: ["menu-item-click", "created"],
  components: {
    XmTooltip: Tooltip
  },
  setup: function setup(props2, context) {
    return _setup({
      props: props2,
      context,
      renderless,
      api
    });
  }
});
function _sfc_render(_ctx, _cache, $props, $setup, $data, $options) {
  var _component_xm_tooltip = resolveComponent("xm-tooltip");
  return openBlock(), createBlock(Transition, {
    name: "xm-zoom-in-top",
    duration: 150,
    onAfterLeave: _ctx.doDestroy,
    persisted: ""
  }, {
    default: withCtx(function() {
      return [withDirectives(createElementVNode(
        "ul",
        {
          "data-tag": "xm-dropdown-menu",
          class: normalizeClass(_ctx.m("min-w-[theme(spacing.18)] max-w-[theme(spacing.52)] absoulte bg-color-bg-1", {
            "py-1.5": _ctx.state.size === "medium"
          }, {
            "py-1.5": _ctx.state.size === "small"
          }, {
            "py-0.75": _ctx.state.size === "mini"
          }, {
            "overflow-x-hidden scrollbar-size-0": _ctx.maxHeight
          }, _ctx.multiStage ? "!block  rounded-none" : "rounded sm:my-1 py-1 my-2 shadow-sm sm:shadow-md", _ctx.popperClass)),
          style: normalizeStyle("max-height:" + _ctx.maxHeight + "px")
        },
        [createVNode(_component_xm_tooltip, {
          ref: "tooltip",
          effect: "light",
          content: _ctx.state.label,
          placement: "top-start",
          manual: true,
          modelValue: _ctx.state.showContent,
          "onUpdate:modelValue": _cache[0] || (_cache[0] = function($event) {
            return _ctx.state.showContent = $event;
          })
        }, null, 8, ["content", "modelValue"]), renderSlot(_ctx.$slots, "default", {
          selectedIndex: _ctx.state.selectedIndex
        })],
        6
        /* CLASS, STYLE */
      ), [[vShow, _ctx.state.showPopper]])];
    }),
    _: 3
    /* FORWARDED */
  }, 8, ["onAfterLeave"]);
}
var mobileFirst = /* @__PURE__ */ _export_sfc(_sfc_main, [["render", _sfc_render]]);
export {
  mobileFirst as default
};
